% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WpoisCI.R
\name{WpoisCI_upper}
\alias{WpoisCI_upper}
\title{An Admissible Exact One-sided Upper Confidence Interval for Poisson Mean}
\usage{
WpoisCI_upper(x, conf.level = 0.95, details = FALSE)
}
\arguments{
\item{x}{the sample or the observed point.}

\item{conf.level}{confidence level. The default is 0.95.}

\item{details}{TRUE/FALSE, can be abbreviated. To choose whether to compute
the confidence intervals for all the sample points. Default is FALSE.}
}
\value{
a list which contain the one-sided upper confidence interval.
}
\description{
The 1-alpha Clopper-Pearson type upper interval for the Poisson
mean.
}
\examples{
WpoisCI_upper(1)
WpoisCI_upper(3,details = TRUE)
}
\references{
Garwood, F. (1936). Fiducial Limits for the Poisson
Distribution. "Biometrika" 28:	437-442.
}
